#ifndef CAR_WASH
#define CAR_WASH

#include <string>
#include <queue>
#include <iostream>

#include "car.h"

using namespace std;


class CarWash
{
    protected:

        const static int INFINITY; // indicates no car being washed

        const static int MAX_SIZE; // maximum cars allowed in carQueue

        static const int WASH_TIME; // minutes to wash one car

        int currentTime,
            nextDepartureTime,
            numberOfCars,
            sumOfWaitingTimes;

        // Postcondition: a car has arrived and has either been turned away --
        //                if the queue was full before this message was sent --
        //                or has entered this CarWash.
        void processArrival(int nextArrivalTime, queue<Car>& carQueue);


        // Postcondition: a car has finished getting washed.
        void processDeparture(queue<Car>& carQueue);


    public:

        // Postcondition: the CarWash is empty.
        CarWash();


        // Postcondition: all of the arrivals and departures for this CarWash
        //                have been processed.
        void runSimulation();


        // Postcondition: the average waiting time, or an error has been printed.
	void printResult();
}; // class CarWash
#endif
